Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Analyzers/BestSchedulingSolutionAnalyzer.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Analyzers/BestSchedulingSolutionAnalyzer.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Analyzers/BestSchedulingSolutionAnalyzer.cs	(revision 6260)
@@ -121,6 +121,6 @@
         if (max && bestSolution.Quality.Value < qualities[i].Value ||
           !max && bestSolution.Quality.Value > qualities[i].Value) {
-            bestSolution = (Schedule)solutions[i].Clone();
           bestSolution.Quality.Value = qualities[i].Value;
+          bestSolution.Resources = (ItemList<Resource>)solutions[i].Resources.Clone();
         }
       }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPCreator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPCreator.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPCreator.cs	(revision 6260)
@@ -34,5 +34,5 @@
   [Item("JobShop Scheduling Problem Creator", "Represents the generalized form of creators for JobShop Scheduling Problems.")]
   [StorableClass]
-  public abstract class JSSPCreator<T> :JSSPOperator, IJSSPCreator where T : Item, IJSSPEncoding{
+  public abstract class JSSPCreator<T> :JSSPOperator, ISchedulingCreator where T : Item, ISchedulingEncoding{
     [StorableConstructor]
     protected JSSPCreator(bool deserializing) : base(deserializing) { }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPCrossover.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPCrossover.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPCrossover.cs	(revision 6260)
@@ -30,12 +30,12 @@
   [Item("JSSPCrossover", "A scheduling crossover operation.")]
   [StorableClass]
-  public abstract class JSSPCrossover : JSSPOperator, IJSSPCrossover, IStochasticOperator {
+  public abstract class JSSPCrossover<T> : JSSPOperator, ISchedulingCrossover, IStochasticOperator where T : Item, ISchedulingEncoding {
     #region IJSSPCrossover Members
-    public ILookupParameter<ItemArray<IJSSPEncoding>> ParentsParameter {
-      get { return (ScopeTreeLookupParameter<IJSSPEncoding>)Parameters["Parents"]; }
+    public ILookupParameter<ItemArray<T>> ParentsParameter {
+      get { return (ScopeTreeLookupParameter<T>)Parameters["Parents"]; }
     }
 
-    public ILookupParameter<IJSSPEncoding> ChildParameter {
-      get { return (ILookupParameter<IJSSPEncoding>)Parameters["Child"]; }
+    public ILookupParameter<T> ChildParameter {
+      get { return (ILookupParameter<T>)Parameters["Child"]; }
     }
     #endregion
@@ -47,5 +47,5 @@
     [StorableConstructor]
     protected JSSPCrossover(bool deserializing) : base(deserializing) { }
-    protected JSSPCrossover(JSSPCrossover original, Cloner cloner)
+    protected JSSPCrossover(JSSPCrossover<T> original, Cloner cloner)
       : base(original, cloner) {
     }
@@ -53,7 +53,7 @@
       : base() {
         Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
-      Parameters.Add(new ScopeTreeLookupParameter<IJSSPEncoding>("Parents", "The parent solution which should be crossed."));
+      Parameters.Add(new ScopeTreeLookupParameter<T>("Parents", "The parent solution which should be crossed."));
       ParentsParameter.ActualName = "SchedulingSolution";
-      Parameters.Add(new LookupParameter<IJSSPEncoding>("Child", "The child solution resulting from the crossover."));
+      Parameters.Add(new LookupParameter<T>("Child", "The child solution resulting from the crossover."));
       ChildParameter.ActualName = "SchedulingSolution";
     }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPDecoder.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPDecoder.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPDecoder.cs	(revision 6260)
@@ -31,5 +31,5 @@
 
 namespace HeuristicLab.Problems.Scheduling.Encodings {
-  public abstract class JSSPDecoder<T> : JSSPOperator, IJSSPDecoder where T : Item, IJSSPEncoding {
+  public abstract class JSSPDecoder<T> : JSSPOperator, ISchedulingDecoder where T : Item, ISchedulingEncoding {
     [StorableConstructor]
     protected JSSPDecoder(bool deserializing) : base(deserializing) { }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPEncodingTypes.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPEncodingTypes.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPEncodingTypes.cs	(revision 6260)
@@ -7,5 +7,6 @@
   public enum JSSPEncodingTypes {
     JSMEncoding,
-    PRVEncoding
+    PRVEncoding,
+    PWREncoding
   }
 }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPManipulator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPManipulator.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPManipulator.cs	(revision 6260)
@@ -30,9 +30,9 @@
   [Item("JSSPManipulator", "A JSSP manipulation operation.")]
   [StorableClass]
-  public abstract class JSSPManipulator : JSSPOperator, IJSSPManipulator, IStochasticOperator {
+  public abstract class JSSPManipulator<T> : JSSPOperator, ISchedulingManipulator, IStochasticOperator where T : Item, ISchedulingEncoding {
     #region IJSSPManipulator Members
 
-    public ILookupParameter<IJSSPEncoding> SchedulingSolutionParameter {
-      get { return (ILookupParameter<IJSSPEncoding>)Parameters["SchedulingSolution"]; }
+    public ILookupParameter<T> SchedulingSolutionParameter {
+      get { return (ILookupParameter<T>)Parameters["SchedulingSolution"]; }
     }
 
@@ -45,10 +45,10 @@
     [StorableConstructor]
     protected JSSPManipulator(bool deserializing) : base(deserializing) { }
-    protected JSSPManipulator(JSSPManipulator original, Cloner cloner)
+    protected JSSPManipulator(JSSPManipulator<T> original, Cloner cloner)
       : base(original, cloner) {
     }
     public JSSPManipulator()
       : base() {
-        Parameters.Add(new LookupParameter<IJSSPEncoding>("SchedulingSolution", "The JSSP solution to be manipulated."));
+        Parameters.Add(new LookupParameter<T>("SchedulingSolution", "The JSSP solution to be manipulated."));
         Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
     }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPOperator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPOperator.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JSSPOperator.cs	(revision 6260)
@@ -35,5 +35,5 @@
   [Item("SchedulingOperator", "A scheduling operator.")]
   [StorableClass]
-  public abstract class JSSPOperator : SingleSuccessorOperator, IJSSPOperator{
+  public abstract class JSSPOperator : SingleSuccessorOperator, ISchedulingOperator{
     [StorableConstructor]
     protected JSSPOperator(bool deserializing) : base(deserializing) { }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMCrossover.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMCrossover.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMCrossover.cs	(revision 6260)
@@ -30,5 +30,5 @@
   [Item("JSMCrossover", "An operator which crosses two JSM representations.")]
   [StorableClass]
-  public abstract class JSMCrossover : JSSPCrossover, IJSMOperator {
+  public abstract class JSMCrossover : JSSPCrossover<JSMEncoding>, IJSMOperator {
 
     [StorableConstructor]
@@ -39,8 +39,8 @@
     }
 
-    public abstract IJSSPEncoding Crossover(IRandom random, JSMEncoding parent1, JSMEncoding parent2);
+    public abstract JSMEncoding Crossover(IRandom random, JSMEncoding parent1, JSMEncoding parent2);
 
     public override IOperation Apply() {
-      ItemArray<IJSSPEncoding> parents = ParentsParameter.ActualValue;
+      ItemArray<JSMEncoding> parents = ParentsParameter.ActualValue;
 
       ChildParameter.ActualValue =
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs	(revision 6260)
@@ -46,9 +46,9 @@
     public JSMJOXCrossover() : base() { }
 
-    public static IJSSPEncoding Cross(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+    public static JSMEncoding Cross(IRandom random, JSMEncoding p1, JSMEncoding p2) {
       JSMEncoding result = new JSMEncoding();
 
-      int nrOfResources = parent1.JobSequenceMatrix.Count;
-      int nrOfJobs = parent1.JobSequenceMatrix[0].Length;
+      int nrOfResources = p1.JobSequenceMatrix.Count;
+      int nrOfJobs = p1.JobSequenceMatrix[0].Length;
 
       //Determine randomly which jobindexes persist
@@ -56,5 +56,9 @@
       for (int i = 0; i < persist.Length; i++) {
         persist[i] = random.Next(2) == 1;
-      }
+      }    
+
+      bool dominantParent = random.Next(2) == 1;
+      JSMEncoding parent1 = dominantParent ? p1 : p2;
+      JSMEncoding parent2 = dominantParent ? p2 : p1;
 
       //Fill childmatrix with values
@@ -77,5 +81,5 @@
     }
 
-    public override IJSSPEncoding Crossover(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+    public override JSMEncoding Crossover(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
       return Cross(random, parent1, parent2);
     } 
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMOXCrossover.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMOXCrossover.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMOXCrossover.cs	(revision 6260)
@@ -0,0 +1,62 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix.Crossovers {
+  [Item("JSM Order Crossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
+  [StorableClass]
+  public class JSMOXCrossover : JSMCrossover {
+    [StorableConstructor]
+    protected JSMOXCrossover(bool deserializing) : base(deserializing) { }
+    protected JSMOXCrossover(JSMOXCrossover original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new JSMOXCrossover(this, cloner);
+    }
+
+    public JSMOXCrossover() : base() { }
+
+    public static JSMEncoding Cross(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+      JSMEncoding result = new JSMEncoding ();
+
+      for (int i = 0; i < parent1.JobSequenceMatrix.Count; i++) {
+        result.JobSequenceMatrix.Add (
+          HeuristicLab.Encodings.PermutationEncoding.OrderCrossover.Apply(random, 
+          parent1.JobSequenceMatrix[i], parent2.JobSequenceMatrix[i]));
+      }
+
+      return result;
+    }
+
+    public override JSMEncoding Crossover(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+      return Cross(random, parent1, parent2);
+    } 
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs	(revision 6260)
@@ -45,8 +45,8 @@
     public JSMSXXCrossover () : base () {}
 
-    public static IJSSPEncoding Cross(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+    public static JSMEncoding Cross(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
       JSMEncoding result = new JSMEncoding();
 
-      int subSequenceLength = 3;
+      int subSequenceLength = random.Next (parent1.JobSequenceMatrix[0].Length);
 
       for (int i = 0; i < parent1.JobSequenceMatrix.Count; i++) {
@@ -102,5 +102,5 @@
 
 
-    public override IJSSPEncoding Crossover(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+    public override JSMEncoding Crossover(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
       return Cross(random, parent1, parent2);
     } 
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMDecoder.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMDecoder.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMDecoder.cs	(revision 6260)
@@ -41,4 +41,5 @@
       : base(original, cloner) {
         this.resultingSchedule = cloner.Clone(original.resultingSchedule);
+        this.jobs = cloner.Clone(original.jobs);
         this.decodingErrorPolicy = original.decodingErrorPolicy;
         this.forcingStrategy = original.forcingStrategy;
@@ -52,12 +53,17 @@
     }
 
+    #region Private Members
     [Storable]
     private Schedule resultingSchedule;
 
     [Storable]
+    private ItemList<JSSPJob> jobs;
+
+    [Storable]
     private JSMDecodingErrorPolicyTypes decodingErrorPolicy = JSMDecodingErrorPolicyTypes.GuidedPolicy;
 
     [Storable]
-    private JSMForcingStrategyTypes forcingStrategy = JSMForcingStrategyTypes.ShiftForcing;
+    private JSMForcingStrategyTypes forcingStrategy = JSMForcingStrategyTypes.ShiftForcing; 
+    #endregion
 
     public JSMDecoder()
@@ -66,5 +72,5 @@
     }
 
-    private ItemList<JSSPTask> GetEarliestNotScheduledTasks(ItemList<JSSPJob> jobs) {
+    private ItemList<JSSPTask> GetEarliestNotScheduledTasks() {
       ItemList<JSSPTask> result = new ItemList<JSSPTask>();
       foreach (JSSPJob j in jobs) {
@@ -79,9 +85,9 @@
     }
     private JSSPTask GetTaskWithMinimalEC(ItemList<JSSPTask> earliestTasksList) {
-      DoubleValue minEct = new DoubleValue(Double.MaxValue);
+      double minEct = double.MaxValue;
       JSSPTask result = null;
       foreach (JSSPTask t in earliestTasksList) {
-        DoubleValue ect = ComputeEarliestCompletionTime(t);
-        if (ect.Value < minEct.Value) {
+        double ect = resultingSchedule.ComputeEarliestCompletionTime(t, jobs[t.JobNr.Value]);
+        if (ect < minEct) {
           result = t;
           minEct = ect;
@@ -92,9 +98,9 @@
     private ItemList<JSSPTask> GetConflictSetForTask(JSSPTask conflictedTask, ItemList<JSSPTask> earliestTasksList) {
       ItemList<JSSPTask> result = new ItemList<JSSPTask>();
-      DoubleValue conflictedCompletionTime = ComputeEarliestCompletionTime(conflictedTask);
+      double conflictedCompletionTime = resultingSchedule.ComputeEarliestCompletionTime(conflictedTask, jobs[conflictedTask.JobNr.Value]);
       result.Add(conflictedTask);
       foreach (JSSPTask t in earliestTasksList) {
         if (t.ResourceNr.Value == conflictedTask.ResourceNr.Value) {
-          if (ComputeEarliestStartTime(t).Value < conflictedCompletionTime.Value)
+          if (resultingSchedule.ComputeEarliestStartTime(t, jobs[t.JobNr.Value]) < conflictedCompletionTime)
             result.Add(t);
         }
@@ -102,89 +108,71 @@
       return result;
     }
-    private JSSPTask SelectTaskFromConflictSet(IntValue conflictedResource, ItemList<JSSPTask> conflictSet, ItemList<Permutation> jsm) {
-      JSSPTask result = null;
-      IntValue progressOnResource = new IntValue (resultingSchedule.Resources[conflictedResource.Value].Tasks.Count);
-
-      if (progressOnResource.Value < jsm[conflictedResource.Value].Length) {
-        IntValue solutionCandidateJobNr = new IntValue(jsm[conflictedResource.Value][progressOnResource.Value]);
-        foreach (JSSPTask t in conflictSet) {
-          if (t.Job.Index.Value == solutionCandidateJobNr.Value)
-            result = t;
-        }
+    private JSSPTask SelectTaskFromConflictSet(int conflictedResourceNr, int progressOnConflictedResource, ItemList<JSSPTask> conflictSet, ItemList<Permutation> jsm) {
+      if (conflictSet.Count == 1)
+        return conflictSet[0];
+      
+      //get solutionCandidate from jobSequencingMatrix
+      int solutionCandidateJobNr = jsm[conflictedResourceNr][progressOnConflictedResource];
+
+      //scan conflictSet for given solutionCandidate, and return if found
+      foreach (JSSPTask t in conflictSet) {
+        if (t.JobNr.Value == solutionCandidateJobNr)
+          return t;
+      }
+
+      //if solutionCandidate wasn't found in conflictSet apply DecodingErrorPolicy and ForcingPolicy
+      JSSPTask result = ApplyDecodingErrorPolicy(conflictSet, jsm[conflictedResourceNr], progressOnConflictedResource);
+      int newResolutionIndex = 0;
+
+      while (newResolutionIndex < jsm[conflictedResourceNr].Length && jsm[conflictedResourceNr][newResolutionIndex] != result.JobNr.Value)
+        newResolutionIndex++;
+      ApplyForcingStrategy(jsm, conflictedResourceNr, newResolutionIndex, progressOnConflictedResource, result.JobNr.Value);
+
+      return result;
+    }
+    private JSSPTask ApplyDecodingErrorPolicy(ItemList<JSSPTask> conflictSet, Permutation resource, int progress) {
+      if (decodingErrorPolicy == JSMDecodingErrorPolicyTypes.RandomPolicy) { 
+        //Random
+        return conflictSet[RandomParameter.ActualValue.Next(conflictSet.Count - 1)];
       } else {
-        return null;
-      }
-
-      //Repairing happens here
-      if (result == null) {
-        //Decoding Error Policy BEGIN
-        //CHOOSE OTHER RESOLUTION FOR CONFLICT SET
-        result = ApplyDecodingErrorPolicy(conflictSet);
-        //result = conflictSet[RandomParameter.ActualValue.Next(conflictSet.Count - 1)];
-        //Decoding Error Policy END
-
-
-        //Determine index of new resolution
-        int index = 0;
-        while (index < jsm[conflictedResource.Value].Length && 
-          jsm[conflictedResource.Value][index] != result.Job.Index.Value)
-          index++;
-
-
-        //Forcing Strategy BEGIN
-        ApplyForcingStrategy(jsm, conflictedResource.Value, index, progressOnResource.Value, result.Job.Index.Value);
-        
-        //ForcingStrategy END
-      }
-      return result;
-    }
-
+        //Guided
+        for (int i = progress; i < resource.Length; i++) {
+          int j = 0;
+          while (j < conflictSet.Count && conflictSet[j].JobNr.Value != resource[i])
+            j++;
+
+          if (j < conflictSet.Count)
+            return (conflictSet[j]);
+        }
+        return conflictSet[RandomParameter.ActualValue.Next(conflictSet.Count - 1)];
+      }    
+    }
     private void ApplyForcingStrategy(ItemList<Permutation> jsm, int conflictedResource, int newResolutionIndex, int progressOnResource, int newResolution) {
-      //if (forcingStrategy == JSMForcingStrategyTypes.SwapForcing) {
+      if (forcingStrategy == JSMForcingStrategyTypes.SwapForcing) {
         //SwapForcing
         jsm[conflictedResource][newResolutionIndex] = jsm[conflictedResource][progressOnResource];
         jsm[conflictedResource][progressOnResource] = newResolution;
-      /*} else {
+      } else {
         //ShiftForcing
-
-      } */
-    }
-
-    private JSSPTask ApplyDecodingErrorPolicy(ItemList<JSSPTask> conflictSet) {
-      //if (decodingErrorPolicy == JSMDecodingErrorPolicyTypes.RandomPolicy) { 
-        //Random
-        return conflictSet[RandomParameter.ActualValue.Next(conflictSet.Count - 1)];
-      /*} else {
-        //Guided
-
-      }    */
-    }
-    private DoubleValue ComputeEarliestStartTime(JSSPTask t) {
-      Resource affectedResource = resultingSchedule.Resources[t.ResourceNr.Value];
-
-      DoubleValue lastMachineEndTime = affectedResource.TotalDuration;
-      DoubleValue previousJoboperationEndTime = new DoubleValue(double.MinValue);
-      if (t.PreviousTask != null)
-        previousJoboperationEndTime = t.PreviousTask.EndTime;
-
-      return new DoubleValue(Math.Max(previousJoboperationEndTime.Value, lastMachineEndTime.Value));
-    }
-    private DoubleValue ComputeEarliestCompletionTime(JSSPTask t) {
-      return new DoubleValue(ComputeEarliestStartTime(t).Value + t.Duration.Value);
-    }
-    private void AddTaskToSchedule(JSSPTask selectedTask) {
-      Resource affectedResource = resultingSchedule.Resources[selectedTask.ResourceNr.Value];
-      selectedTask.StartTime = ComputeEarliestStartTime(selectedTask);
-      selectedTask.IsScheduled.Value = true;
-      affectedResource.Tasks.Add(selectedTask);
-    }
-
-    public override Schedule CreateScheduleFromEncoding(JSMEncoding solution) {
+        List<int> asList = jsm[conflictedResource].ToList<int>();
+        if (newResolutionIndex > progressOnResource) {
+          asList.RemoveAt(newResolutionIndex);
+          asList.Insert(progressOnResource, newResolution);
+        } else {
+          asList.Insert(progressOnResource, newResolution); 
+          asList.RemoveAt(newResolutionIndex);
+        }
+        jsm[conflictedResource] = new Permutation (PermutationTypes.Absolute, asList.ToArray<int>());
+      } 
+    }
+
+    public Schedule CreateScheduleFromEncoding(JSMEncoding solution, ItemList<JSSPJob> jobData) {
       ItemList<Permutation> jobSequenceMatrix = solution.JobSequenceMatrix;
 
-      resultingSchedule = new Schedule(new IntValue(Jobs[0].Tasks.Count));
+      jobs = (ItemList<JSSPJob>)jobData.Clone();
+      resultingSchedule = new Schedule(new IntValue(jobs[0].Tasks.Count));
 
       //Reset scheduled tasks in result
-      foreach (JSSPJob j in Jobs) {
+      foreach (JSSPJob j in jobs) {
         foreach (JSSPTask t in j.Tasks) {
           t.IsScheduled.Value = false;
@@ -194,23 +182,31 @@
       //GT-Algorithm
       //STEP 0 - Compute a list of "earliest operations"
-      ItemList<JSSPTask> earliestTasksList = GetEarliestNotScheduledTasks(Jobs);
+      ItemList<JSSPTask> earliestTasksList = GetEarliestNotScheduledTasks();
       while (earliestTasksList.Count > 0) {
         //STEP 1 - Get earliest not scheduled operation with minimal earliest completing time
         JSSPTask minimal = GetTaskWithMinimalEC(earliestTasksList);
-
-        //STEP 2 - Compute a conflict set of all operations that can be scheduled on the machine the previously selected operation runs on
+        int conflictedResourceNr = minimal.ResourceNr.Value;
+        Resource conflictedResource = resultingSchedule.Resources[conflictedResourceNr];
+
+        //STEP 2 - Compute a conflict set of all operations that can be scheduled on the conflicted resource
         ItemList<JSSPTask> conflictSet = GetConflictSetForTask(minimal, earliestTasksList);
 
-        //STEP 3 - Select an operation from the conflict set (various methods depending on how the algorithm should work..)
-        JSSPTask selectedTask = SelectTaskFromConflictSet(minimal.ResourceNr, conflictSet, jobSequenceMatrix);
-
-        //STEP 4 - Adding the selected operation to the current schedule
-        AddTaskToSchedule(selectedTask);
+        //STEP 3 - Select a task from the conflict set
+        int progressOnResource = conflictedResource.Tasks.Count;
+        JSSPTask selectedTask = SelectTaskFromConflictSet(conflictedResourceNr, progressOnResource, conflictSet, jobSequenceMatrix);
+
+        //STEP 4 - Add the selected task to the current schedule 
+        selectedTask.IsScheduled.Value = true;
+        resultingSchedule.AddTask(selectedTask, jobs[selectedTask.JobNr.Value]);
 
         //STEP 5 - Back to STEP 1
-        earliestTasksList = GetEarliestNotScheduledTasks(Jobs);
+        earliestTasksList = GetEarliestNotScheduledTasks();
       }
 
       return resultingSchedule;
+    }
+
+    public override Schedule CreateScheduleFromEncoding(JSMEncoding solution) {
+      return CreateScheduleFromEncoding(solution, Jobs);
     }
 
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMEncoding.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMEncoding.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/JSMEncoding.cs	(revision 6260)
@@ -36,5 +36,5 @@
   [Item("Job Sequencing Matrix Encoding", "Represents a solution for a standard JobShop Scheduling Problem.")]
   [StorableClass]
-  public class JSMEncoding : ParameterizedNamedItem, IJSSPEncoding{
+  public class JSMEncoding : ParameterizedNamedItem, ISchedulingEncoding{
     [StorableConstructor]
     protected JSMEncoding(bool deserializing) : base(deserializing) { }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Manipulators/JSMManipulator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Manipulators/JSMManipulator.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Manipulators/JSMManipulator.cs	(revision 6260)
@@ -32,5 +32,5 @@
   [Item("AlbaManipulator", "An operator which manipulates a VRP representation.")]
   [StorableClass]
-  public abstract class JSMManipulator : JSSPManipulator, IJSMOperator {
+  public abstract class JSMManipulator : JSSPManipulator<JSMEncoding>, IJSMOperator {
     [StorableConstructor]
     protected JSMManipulator(bool deserializing) : base(deserializing) { }
@@ -44,7 +44,10 @@
 
     public override IOperation Apply() {
-      IJSSPEncoding solution = SchedulingSolutionParameter.ActualValue;
+      JSMEncoding solution = SchedulingSolutionParameter.ActualValue;
 
-      SchedulingSolutionParameter.ActualValue = Manipulate(RandomParameter.ActualValue, solution as JSMEncoding);
+      int nrOfMutations = RandomParameter.ActualValue.Next(5) + 1;
+
+      for (int i = 0; i < nrOfMutations; i++ )
+        SchedulingSolutionParameter.ActualValue = Manipulate(RandomParameter.ActualValue, solution as JSMEncoding);
 
       return base.Apply();
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs	(revision 6260)
@@ -0,0 +1,59 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.PermutationEncoding;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix.Manipulators {
+
+  [Item("JSM Swap Manipulator", "Represents a manipulation operation inserting parts of the individual at another position.")]
+  [StorableClass]
+  public class JSMSwapManipulator : JSMManipulator {
+    [StorableConstructor]
+    protected JSMSwapManipulator(bool deserializing) : base(deserializing) { }
+    protected JSMSwapManipulator(JSMSwapManipulator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new JSMSwapManipulator(this, cloner);
+    }
+
+    public JSMSwapManipulator () : base () {}
+
+    protected override JSMEncoding Manipulate(IRandom random, JSMEncoding individual) {
+      JSMEncoding result = (JSMEncoding)individual.Clone();
+      int resourceIndex = random.Next(result.JobSequenceMatrix.Count);
+      Permutation p = result.JobSequenceMatrix[resourceIndex];
+      int seqIndex1 = random.Next(p.Length);
+      int seqIndex2 = random.Next(p.Length);
+      int aux = p[seqIndex1];
+      p[seqIndex1] = p[seqIndex2];
+      p[seqIndex2] = aux;
+      return result;
+    }
+  }
+}
